# avoid dependency on X11 libraries
%define without_x       1

%define subrel	3

Summary:	A user-friendly file manager and visual shell
Name:		mc
Version:	4.6.1
Release:	%mkrel 6
License:	GPL
Group:		File tools
URL:		http://www.ibiblio.org/mc/
Source0:	ftp://ftp.gnome.org:/pub/GNOME/stable/sources/mc/%{name}-%{version}.tar.bz2
# Changelogs for Advanced Midnight Commander patches
Source1:	http://www1.mplayerhq.hu/~arpi/amc/amc-1.txt
Source2:	http://www1.mplayerhq.hu/~arpi/amc/amc-2.txt
#(dam's)
Patch23:	mc-4.6.0-toolbar-po-mdk.path
# (tv) add runlevel to initscript
Patch31:	mc-4.6.0-init.patch
# (fc) fix xpdf outputing garbage on stdout (bug #4094)
Patch0:		mc-4.6.0-xpdf.patch
# remove copyright tag, and s/serial/epoch tag in rpm vfs
Patch1:		mc-4.6.1-rpm_obsolete_tags.patch
# (mpol) 4.6.0-9mdk
Patch6:		mc-4.6.0-ptsname.patch
# (mpol) 4.6.0-9mdk utf8 patches from fedora/suse
Patch7:		mc-4.6.1-utf8.patch
Patch8:		mc-4.6.1-bourne-compliancy.patch
Patch9:		mc-4.6.1-decent_defaults.diff
# PLD patches P100 - P113
Patch100:	mc-spec-syntax.patch
Patch101:	mc-urar.patch
Patch102:	mc-srpm.patch
# Advanced Midnight Commander patches
#changed from:	http://www1.mplayerhq.hu/~arpi/amc/amc-1.diff
Patch103:	amc-1.diff
#changed from:	http://www1.mplayerhq.hu/~arpi/amc/amc-2.diff
Patch104:	amc-2.diff
Patch105:	mc-mc.ext.patch
Patch106:	mc-mo.patch
# at now syntax highligthing for PLD-update-TODO and CVSROOT/users
Patch107:	mc-pld-developerfriendly.patch
# http://www.suse.de/~nadvornik/mc.html
Patch108:	mc-64bit.patch
Patch109:	mc-fish-upload.patch
Patch110:	mc-nolibs.patch
Patch111:	mc-ftpcrash.patch
Patch112:	mc-symcrash.patch
Patch113:	mc-userhost.patch
Patch114:	mc-4.6.1.lzma.patch
Requires:	groff
Requires:	slang > 1.4.9-5mdk
BuildRequires:	libext2fs-devel
BuildRequires:	libgpm-devel >= 0.18
BuildRequires:	pam-devel
BuildRequires:	slang-devel > 1.4.9-5mdk
BuildRequires:	glib2-devel
BuildRequires:  autoconf2.5
%if %without_x
%else
BuildRequires:	XFree86-devel
%endif
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Midnight Commander is a visual shell much like a file manager, only with way
more features.  It is text mode, but also includes mouse support if you are
running GPM.  Its coolest feature is the ability to ftp, view tar, zip
files, and poke into RPMs for specific files.  :-)

%prep

%setup -q -n %{name}-%{version}

%patch0 -p1 -b .xpdf
%patch1 -p1 -b .rpm_obsolete_tags
%patch23 -p1 -b .toolbarpo
%patch31 -p1 -b .initlevel
# fixme: disabled P6
#%%patch6 -p1 -b .ptsname
%patch7 -p1 -b .utf8
%patch8 -p1 -b .bourne_compliancy
%patch9 -p0 -b .decent_defaults

# PLD patches
%patch100 -p1
%patch101 -p1
cp -f vfs/extfs/{rpm,srpm}
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1
%patch110 -p1
%patch111 -p1
%patch112 -p1
%patch113 -p1
%patch114 -p1 -b .lzma

sed -i 's:|hxx|:|hh|hpp|hxx|:' syntax/Syntax

%build

# Convert translated files to UTF-8: bugs #31578, #31542, #31663 - AdamW 2007/06

pushd doc
# italian is already unicode, leave it out.
for i in es hu pl ru sr; do pushd $i; \
# this is ugly, but assume same encoding as .po file for each language.
iconv --from-code=`grep charset= ../../po/$i.po | cut -c36- | head -c-4 | tr "[:lower:]" "[:upper:]"` --to-code=UTF-8 mc.1.in > mc.1.in.new; \
iconv --from-code=`grep charset= ../../po/$i.po | cut -c36- | head -c-4 | tr "[:lower:]" "[:upper:]"` --to-code=UTF-8 xnc.hlp > xnc.hlp.new; \
mv -f mc.1.in.new mc.1.in; mv -f xnc.hlp.new xnc.hlp; popd; done
popd

pushd lib
# rename zh to zh_TW, which is what it really is (I think)
mv mc.hint.zh mc.hint.zh_TW
perl -pi -e 's,mc.hint.zh,mc.hint.zh_TW,g' Makefile.am
# hardcode the list as we need to leave italian out and it just gets ugly doing it 'smartly'...
for i in cs es hu nl pl ru sr uk zh_TW; \
# this is ugly, but assume same encoding as .po file for each language.
do iconv --from-code=`grep charset= ../po/$i.po | cut -c36- | head -c-4 | tr "[:lower:]" "[:upper:]"` --to-code=UTF-8 mc.hint.$i > mc.hint.$i.new; \
mv -f mc.hint.$i.new mc.hint.$i; done
popd

pushd po
# remove the original .mo files
rm -f *.gmo
# find stuff that's not Unicode already
for i in `file *.po | grep -v Unicode | cut -d: -f1`; \
# convert it: the grep, cut, head, tr grabs the source encoding from the .po file header, there's no other way to find it
do iconv --from-code=`grep charset= $i | cut -c36- | head -c-4 | tr "[:lower:]" "[:upper:]"` --to-code=UTF-8 $i > $i.new; \
# change the header to say UTF-8
mv -f $i.new $i; perl -pi -e 's,charset=.*$,charset=UTF-8\\n",g' $i; done
# regenerate the .mo files
for i in `ls *.po | cut -d. -f1`; do /usr/bin/msgfmt -c --statistics -o $i.gmo $i.po; done
popd

%{__aclocal} -I m4
%{__autoconf}
%{__automake}

X11_WWW="www-browser" %serverbuild
# libcom_err of e2fsprogs and krb5 conflict. Watch this hack. -- Geoff.
# <hack>
mkdir -p %{_lib}
ln -sf /%{_lib}/libcom_err.so.2 %{_lib}/libcom_err.so
export LDFLAGS="-L`pwd`/%{_lib}"
# </hack>

%configure2_5x \
    --with-debug \
    --without-included-gettext \
    --without-included-slang \
    --with-screen=slang \
    --enable-nls \
    --enable-charset \
    --enable-largefile \
%if %without_x
    --without-x
%endif

# don't use make macro, mc doesn't support parallel compilation
make

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_sysconfdir}/{pam.d,profile.d,X11/wmconfig} $RPM_BUILD_ROOT%{_initrddir}

#fix mc-wrapper.sh
perl -p -i -e 's/rm -f \"/rm -rf \"/g' lib/mc-wrapper.sh

%makeinstall

install lib/{mc.sh,mc.csh} $RPM_BUILD_ROOT%{_sysconfdir}/profile.d

%{find_lang} %{name}

%clean
rm -rf $RPM_BUILD_ROOT


%files -f %{name}.lang
%defattr(-, root, root)
%doc FAQ COPYING NEWS README
%{_bindir}/mc
%{_bindir}/mcedit
%{_bindir}/mcmfmt
%{_bindir}/mcview
%dir %{_libdir}/mc/
%{_libdir}/mc/cons.saver
%{_datadir}/mc/cedit.menu
%{_datadir}/mc/edit.indent.rc
%{_datadir}/mc/edit.spell.rc
%{_datadir}/mc/mc.ext
%{_datadir}/mc/mc.hint
%{_datadir}/mc/mc.hint.*
%{_datadir}/mc/mc.hlp
%{_datadir}/mc/mc.hlp.*
%{_datadir}/mc/mc.lib
%{_datadir}/mc/mc.menu
%{_datadir}/mc/mc.menu.*
%{_datadir}/mc/mc.charsets
%{_datadir}/mc/extfs/*
%{_mandir}/man1/*
%dir %{_datadir}/mc
%dir %{_datadir}/mc/bin
%{_datadir}/mc/bin/*
%{_datadir}/mc/syntax/
#%{_datadir}/mc/term/
%{_sysconfdir}/profile.d/*




%changelog
* Tue Sep 04 2007 Adam Williamson <awilliamson@mandriva.com> 4.6.1-6.3mdv2007.1
+ Revision: 79567
- updated version of patch 109 from Fedora bug #186456 (fixes Mandriva bug #26498)
- more sophisticated and complete UTF-8 conversion
- patch11: fix some invalid control sequences in zh_TW po
- have to convert headers of po files as well
- convert some translations to UTF-8 (#31542)

  + Andreas Hasenack <andreas@mandriva.com>
    - branched cooker into 2007.1 (will have to revert some recent changes)


* Mon Feb 12 2007 Per Øyvind Karlsen <pkarlsen@mandriva.com> 4.6.1-6mdv2007.0
+ Revision: 118891
- add lzma support (P114)

* Thu Nov 02 2006 Oden Eriksson <oeriksson@mandriva.com> 4.6.1-5mdv2007.1
+ Revision: 75591
- Import mc

* Thu Nov 02 2006 Oden Eriksson <oeriksson@mandriva.com> 4.6.1-5mdv2007.1
- bunzip patches

* Fri Aug 25 2006 Oden Eriksson <oeriksson@mandrakesoft.com> 4.6.1-4mdv2007.0
- added P9 to set some defaults
- added PLD patches P100 - P113 (4.6.1-5)

* Fri May 12 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 4.6.1-3mdk
- make mc.sh bash compliant (P8)
- fix executable-marked-as-config-file

* Mon Jan 16 2006 Marcel Pol <mpol@mandriva.org> 4.6.1-2mdk
- remove copyright tag, and s/serial/epoch tag in rpm vfs
  (bug #20662)

* Thu Jul 28 2005 Marcel Pol <mpol@mandriva.org> 4.6.1-1mdk
- 4.6.1 final
- drop P4, fixed upstream
- update P7
- drop P8, merged upstream

* Fri May 06 2005 Marcel Pol <mpol@mandriva.org> 4.6.1-0.pre3.4mdk
- fix logo on help page
- add %%mkrel for backporting

* Fri Apr 22 2005 Marcel Pol <mpol@mandriva.org> 4.6.1-0.pre3.3mdk
- sync utf8 patch7 with Fedora 4.6.1-0.13.FC3

* Sun Feb 13 2005 Marcel Pol <mpol@mandrake.org> 4.6.1-0.pre3.2mdk
- use www-browser

* Sun Feb 13 2005 Marcel Pol <mpol@mandrake.org> 4.6.1-0.pre3.1mdk
- unofficial 4.6.1-pre3
- drop source1, P1, P2, P5, P9, P13, P14, P15, P16, merged upstream
- drop P3, different fix upstream (use id, not $USER)
- rediff P4
- sync utf8 patch with fedora3
  now just one patch; P7, P8, P10, P11, P12 moved into P7
- disable P6 for now
- small cleanups

* Mon Sep 27 2004 Marcel Pol <mpol@mandrake.org> 4.6.0-13mdk
- add requires slang > 1.4.9-5mdk

* Wed Sep 15 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 4.6.0-12mdk
- make the wrapper script work (P3)

* Mon Aug 30 2004 Marcel Pol <mpol@mandrake.org> 4.6.0-11mdk
- security fix for vfs/extfs CAN-2004-0494
- really use gqview for images
- --enable-charset is back
- patch14 add info/obsoletes, info/license to rpm extfs
- patch15 fix crash on use of large syntax file
- patch16 fix coloring of diffs of diffs

* Sat Jul 24 2004 Marcel Pol <mpol@mandrake.org> 4.6.0-10mdk
- again build against new slang
- drop mcserv optional build

* Thu Jul 22 2004 Marcel Pol <mpol@mandrake.org> 4.6.0-9mdk
- update patch1, use gqview for images as upstream does
- add unzip vfs
- drop patch3, merged in patch6 to patch10
- patch5: "secret" redhat cpio fix
- add patch6
- patch7: build against slang-utf8
- patch8, 10, 11, 12: add utf8 patches from fedora/suse
- patch9: (jumbo patch) several fixes, updates, etc.
- disable charset conversion

* Sat May 01 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 4.6.0-8mdk
- Patch3 (stew): security fix for CAN-2004-0226,0231,0232
- Patch4 (stew): disable ta locale - won't compile

* Sun Apr 11 2004 Michael Scherer <misc@mandrake.org> 4.6.0-7mdk 
- [DIRM]

* Tue Feb 17 2004 Marcel Pol <mpol@mandrake.org> 4.6.0-6mdk
- security fix for CAN-2003-1023 (vdanen)

* Mon Feb 16 2004 Marcel Pol <mpol@mandrake.org> 4.6.0-5mdk
- Patch1: image extension s/ee/display (bug #7907)

